## mbr 0.0.1

=== DESCRIPTION ===
Package: mbr
Type: Package
Title: Mass Balance Reconstruction
Version: 0.0.1
Author: Hung Nguyen
Maintainer: Hung Nguyen <ntthung@gmail.com>
Description: Mass-balance-adjusted Regression algorithm for streamflow reconstruction at sub-annual resolution (e.g., seasonal or monthly). The algorithm implements a penalty term to minimize the differences between the total sub-annual flows and the annual flow. The method is described in Nguyen et al (2020) <DOI:10.1002/essoar.10504791.1>.
License: GPL (>= 2.0)
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.5)
Imports: data.table, dplR, MASS, Matrix, Rfast, stats
RoxygenNote: 7.1.1
URL: https://github.com/ntthung/mbr
BugReports: https://github.com/ntthung/mbr/issues
Suggests: knitr, rmarkdown, testthat
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2021-02-12 12:06:00 UTC; ntthu
Repository: CRAN
Date/Publication: 2021-02-16 09:10:02 UTC

## mbr 1.0.0

=== Makefile ===
CC=gcc
CFLAGS=-g
AS=as
AS86=as86
DD=dd
RM=rm
HD=/dev/hda
FD=/dev/fd0

# Rule for preprocessing asm files
%.s: %.S
	$(CC) $(INCLUDE) -E $< -o $@ || \
		( rm -f $@ ; exit 1 )

#%.o: %.s
#	$(AS86) -0 -a -o $@ $< || ( rm -f $@ ; exit 1 )

#%: %.o
#	$(LD86) -0 -s -o $@ $< || ( rm -f $@ ; exit 1 )

# To get from preprocessed asm files to .b files
%.b: %.s
	$(AS86) -0 -a -b $@ -l $*.out $< || ( rm -f $@ ; exit 1 )

# To extract the image
mbr: mbr.b
	$(DD) if=mbr.b of=mbr bs=1 skip=5 count=512

# The dependancies for this rule must be as written. It creates a hex
# assembler file containing the mbr.
mbrobj.s: bin2asm mbr
	$^ $@

ptable:
	$(DD) if=$(HD) bs=512 count=1

floppy: mbr ptable
	$(DD) if=mbr of=$(FD) bs=512 count=1
	$(DD) if=ptable of=$(FD) bs=2 skip=223 seek=223 count=32

install: mbr
	$(DD) if=mbr of=$(HD) bs=446 count=1
	$(DD) if=mbr of=$(HD) bs=1 count=2 skip=510 seek=510

clean:
	$(RM) -rf *.{o,b,s,out} mbr core mbrobj* bin2asm

.PHONY: clean floppy

## mbr 1.0.0-2

=== Makefile ===
CC=gcc
CFLAGS=-g
AS=as
AS86=as86
DD=dd
RM=rm
# HD=/dev/hda
# FD=/dev/fd0

# Rule for preprocessing asm files
%.s: %.S
	$(CC) $(INCLUDE) -E $< -o $@ || \
		( rm -f $@ ; exit 1 )

#%.o: %.s
#	$(AS86) -0 -a -o $@ $< || ( rm -f $@ ; exit 1 )

#%: %.o
#	$(LD86) -0 -s -o $@ $< || ( rm -f $@ ; exit 1 )

# To get from preprocessed asm files to .b files
%.b: %.s
	$(AS86) -0 -a -b $@ -l $*.out $< || ( rm -f $@ ; exit 1 )

# To extract the image
mbr: mbr.b
	$(DD) if=mbr.b of=mbr bs=1 skip=5 count=444

# The dependancies for this rule must be as written. It creates a hex
# assembler file containing the mbr.
mbrobj.s: bin2asm mbr
	$^ $@

# ptable:
# 	$(DD) if=$(HD) bs=512 count=1
# 
# floppy: mbr ptable
# 	$(DD) if=mbr of=$(FD) bs=512 count=1
# 	$(DD) if=ptable of=$(FD) bs=2 skip=223 seek=223 count=32
# 
# install: mbr
# 	$(DD) if=mbr of=$(HD) bs=446 count=1
# 	$(DD) if=mbr of=$(HD) bs=1 count=2 skip=510 seek=510

clean:
	$(RM) -rf *.{o,b,s,out} mbr core mbrobj* bin2asm

.PHONY: clean floppy

## mbr 1.2.1

=== debian/changelog ===
mbr (1.2.1) unstable; urgency=medium

  * Remove report bug message and version number. Closes: #909563.

 -- Santiago Garcia Mantinan <manty@debian.org>  Tue, 25 Sep 2018 21:15:56 +0200

mbr (1.2.0) unstable; urgency=medium

  * Upstream we are.

  [ Santiago Garcia Mantinan ]
  * Make room for Disk signature (6 bytes) by using new parameter format.
  * Remove code to protect Disk signature, we no longer overwrite this.
  * Fix several warnings, update standards and other old stuff.

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #905846)
    + Pass --host to ./configure.
    + Let dpkg's buildtools.mk supply $(CC).
    + Defer all stripping to dh_strip.

 -- Santiago Garcia Mantinan <manty@debian.org>  Thu, 20 Sep 2018 10:05:36 +0200

mbr (1.1.11-5.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Simon McVittie ]
  * Only copy install-mbr to debian/mbr-udeb/sbin if we are going to
    build the mbr-udeb package, fixing FTBFS on non-x86 architectures.
    In recent debhelper versions, dh_installdirs does not create
    directories for binary packages that are not applicable to the
    current architecture.  (Closes: #881835)

  [ Niels Thykier ]
  * Set Rules-Requires-Root (R³) to no.
  * Replace use of "Priority: extra" with "Priority: optional" as the
    former is now obsolete and replaced by the latter.
  * Use Package-Type without the "XC-" prefix as it is no longer
    required.

 -- Niels Thykier <niels@thykier.net>  Mon, 06 Aug 2018 18:53:12 +0000

mbr (1.1.11-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable testsuite on all archs. (Closes: #792126, LP: #445643)

  [ Dejan Latinovic ]
  * Fix FTBFS on ia64, m68k and mips64el by using xxd instead of ld.
    (Closes: #697332)

  [ Lannart Sorensen ]
  * Prevent install-mbr from wiping new style MBRs.
    (Closes: #725417, LP: #814956)

  [ Martin Pitt ]
  * Read UTC setting from /etc/adjtime instead of /etc/default/rcS.
    (Closes: #813671)

 -- James Cowgill <jcowgill@debian.org>  Fri, 21 Oct 2016 10:57:33 +0100

mbr (1.1.11-5) unstable; urgency=low

  * Add dh_md5sums to debian/rules, thanks to jmccrohan. Closes: #672321.
  * Change build targets thanks to lintian.

 -- Santiago Garcia Mantinan <manty@debian.org>  Sun, 13 May 2012 10:24:15 +0200

mbr (1.1.11-4) unstable; urgency=low

  * Try to fix building on kfreebsd-i386 not building the harness.

 -- Santiago Garcia Mantinan <manty@debian.org>  Fri, 15 Apr 2011 19:57:48 +0200

mbr (1.1.11-3) unstable; urgency=low

  * Fix couple of bashishms on tests so that we build on pure i386.
  * Run tests only once.

 -- Santiago Garcia Mantinan <manty@debian.org>  Fri, 15 Apr 2011 19:37:31 +0200

mbr (1.1.11-2) unstable; urgency=low

  * Stop tests on non i386. Closes: #516644.
  * It was also failing on pure i386 when run as nonroot, had to
    remove all the tests that were failing on current kernels.

 -- Santiago Garcia Mantinan <manty@debian.org>  Thu, 14 Apr 2011 20:49:59 +0200

mbr (1.1.11-1) unstable; urgency=low

  * The after a long long wait release.

  [ Santiago Garcia Mantinan ]
  * New upstream version.
  * Change mbr's architecture to any (not for the udeb). Closes: #516644.
  * Bump standards version to 3.9.1.

  [ Cody A.W. Somerville ]  
  * debian/control: Closes: #535098.
    - Add mbr-udeb binary package for use with debian-installer.
    - Add build-dependency on debhelper.
  * debian/compat: Set to level debhelper compat level 7
  * debian/rules: Rewrote to use debhelper.

 -- Santiago Garcia Mantinan <manty@debian.org>  Tue, 05 Apr 2011 22:27:33 +0200

mbr (1.1.10-2) unstable; urgency=low

  * Added patch from upstream, thanks to Loïc for reporting and sending
    the patch. Closes: #509285.

 -- Santiago Garcia Mantinan <manty@debian.org>  Sat, 27 Dec 2008 00:49:19 +0100

mbr (1.1.10-1) unstable; urgency=low

  * New upstream version.
  * Compile with support for large files. Closes: #418297.
  * Add support for lpia architecture. Closes: #454203.
  * Get a 64-bit installer where available. Closes: #382812.

 -- Santiago Garcia Mantinan <manty@debian.org>  Sat, 29 Dec 2007 20:15:27 +0100

mbr (1.1.9-3) unstable; urgency=low

  * Fix FTBFS on amd64 (Thanks Daniel). Closes: #434307.
  * Fix FTBFS on i386 64 bits (Thanks Daniel and Colin). Closes: #439283.
  * Merge Ubuntu's clear the ID flag in test harness output.

 -- Santiago Garcia Mantinan <manty@debian.org>  Mon, 08 Oct 2007 21:25:11 +0200

mbr (1.1.9-2) unstable; urgency=low

  * Fix FTBFS on new kernels. Closes: #392776.
  * Bashisms should be now gone. Closes: #382586.

 -- Santiago Garcia Mantinan <manty@debian.org>  Sat, 25 Nov 2006 20:41:01 +0100

mbr (1.1.9-1) unstable; urgency=low

  * New upstream version.

 -- Santiago Garcia Mantinan <manty@debian.org>  Tue,  3 Oct 2006 19:48:03 +0200

mbr (1.1.8-2) unstable; urgency=low

  * Change section to accomodate to override.

 -- Santiago Garcia Mantinan <manty@debian.org>  Tue, 23 May 2006 00:02:53 +0200

mbr (1.1.8-1) unstable; urgency=low

  * The "I thought nobody used mbr anymore" release.

  [ Santiago Garcia Mantinan ]
  * New upstream version.
  * Bump up Standards-Version.
  * Change description so that it is OS independant.

  [ Goswin von Brederlow ]
  * Port to amd64 (closes: #330190)
    + debian/rules: set CC and LD
    + debian/rules: add -W to CFLAGS for proper warnings
    + debian/control: Build-Depend on libc6-dev-i386 [amd64] and
      (temporary) on ia32-libs [amd64] for dpkg-shlibdeps to work
  * Fix potentialy harmfull warnings
    + harness/args.c:57: warning: suggest parentheses around arithmetic
    + harness/output.c:22: warning: comparison between signed and unsigned
    + harness/process.c:25: warning: implicit declaration of function 'exit'
    + install-mbr.c:617: warning: return type defaults to 'int'
    + install-mbr.c:702: warning: comparison between signed and unsigned
    + install-mbr.c:1357: warning: format '%d' expects type 'int', but
      argument 4 has type 'char *'


=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
-include /usr/share/dpkg/buildtools.mk

binaries := $(shell dh_listpackages)

CC := $(CC) -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

CFLAGS := -g -Wall -W
INSTALL_PROGRAM := install

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -O2
endif

build: build-arch build-indep

build-arch: build-stamp

build-indep: build-stamp

build-stamp:
	./configure --exec-prefix=`pwd`/debian/mbr/ --prefix=`pwd`/debian/mbr/usr --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
	$(MAKE) CC="$(CC)" LD="$(LD)" CFLAGS="$(CFLAGS)"
	touch build

clean:
	dh_testdir
	dh_testroot
	dh_clean
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f build

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -p mbr-udeb sbin
	dh_installdocs -p mbr debian/README-1st.Debian NEWS README AUTHORS
	dh_installchangelogs
	$(MAKE) install INSTALL_PROGRAM="$(INSTALL_PROGRAM)"
ifneq ($(filter mbr-udeb,$(binaries)),)
	cp `pwd`/debian/mbr/sbin/install-mbr `pwd`/debian/mbr-udeb/sbin/
endif

binary-indep: build
	dh_testdir

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_strip
	dh_compress
	dh_fixperms
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean

## mbr 1.2.1build1

=== debian/changelog ===
mbr (1.2.1build1) hirsute; urgency=medium

  * No-change rebuild to drop the udeb package.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2021 10:35:26 +0100

=== debian/control ===
Source: mbr
Section: admin
Priority: optional
Maintainer: Santiago Garcia Mantinan <manty@debian.org>
Standards-Version: 4.2.1
Build-Depends: debhelper(>= 7), bin86, util-linux (>= 2.13) | linux32, xxd
Rules-Requires-Root: no

Package: mbr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Master Boot Record for IBM-PC compatible computers.
 The MBR is used in booting operating systems from the hard disk. It
 runs first, then transfers control to the operating system's loader
 which transfers control to the kernel.

Package: mbr-udeb
Architecture: i386 amd64 lpia
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: debian-installer
Package-Type: udeb
XB-Installer-Menu-Item: 99999
Description: Master Boot Record for IBM-PC compatible computers

## mbr 1.2.1+nmu1

=== debian/changelog ===
mbr (1.2.1+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 15:55:17 +0800

## mbr 1.2.2

=== debian/changelog ===
mbr (1.2.2) unstable; urgency=medium

  [ Santiago Garcia Mantinan ]
  * Update debhelper compat version.

  [ Helmut Grohne ]
  * Move install-mbr to /usr. (Closes: #1063570)

 -- Santiago Garcia Mantinan <manty@debian.org>  Mon, 19 Feb 2024 22:20:52 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Santiago Garcia Mantinan <manty@debian.org>
 Standards-Version: 4.2.1
-Build-Depends: debhelper(>= 7), bin86, util-linux (>= 2.13) | linux32, xxd
+Build-Depends: debhelper(>= 13), bin86, util-linux (>= 2.13) | linux32, xxd
 Rules-Requires-Root: no
 
 Package: mbr

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,7 @@
 build-indep: build-stamp
 
 build-stamp:
-	./configure --exec-prefix=`pwd`/debian/mbr/ --prefix=`pwd`/debian/mbr/usr --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
+	./configure --prefix=`pwd`/debian/mbr/usr --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
 	$(MAKE) CC="$(CC)" LD="$(LD)" CFLAGS="$(CFLAGS)"
 	touch build
 
@@ -36,12 +36,12 @@
 	dh_testdir
 	dh_testroot
 	dh_prep
-	dh_installdirs -p mbr-udeb sbin
+	dh_installdirs -p mbr-udeb usr/sbin
 	dh_installdocs -p mbr debian/README-1st.Debian NEWS README AUTHORS
 	dh_installchangelogs
 	$(MAKE) install INSTALL_PROGRAM="$(INSTALL_PROGRAM)"
 ifneq ($(filter mbr-udeb,$(binaries)),)
-	cp `pwd`/debian/mbr/sbin/install-mbr `pwd`/debian/mbr-udeb/sbin/
+	cp `pwd`/debian/mbr/usr/sbin/install-mbr `pwd`/debian/mbr-udeb/usr/sbin/
 endif
 
 binary-indep: build

## mbr 1.2.2build1

=== debian/changelog ===
mbr (1.2.2build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 16 Dec 2025 20:00:47 +0000
